Module | Merb::ResponderMixin
In: | lib/merb-core/controller/mixins/responder.rb

The ResponderMixin adds methods that help you manage what formats your controllers have available, determine what format(s) the client requested and is capable of handling, and perform content negotiation to pick the proper content format to deliver.

If you hear someone say "Use provides" they‘re talking about the Responder. If you hear someone ask "What happened to respond_to?" it was replaced by provides and the other Responder methods.

## A simple example

The best way to understand how all of these pieces fit together is with an example. Here‘s a simple web-service ready resource that provides a list of all the widgets we know about. The widget list is available in 3 formats: :html (the default), plus :xml and :text.

        class Widgets < Application
          provides :html   # This is the default, but you can
                           # be explicit if you like.
          provides :xml, :text

          def index
            @widgets = Widget.fetch
            render @widgets
          end
        end

Let‘s look at some example requests for this list of widgets. We‘ll assume they‘re all GET requests, but that‘s only to make the examples easier; this works for the full set of RESTful methods.

1. The simplest case, /widgets.html Since the request includes a specific format (.html) we know what format to return. Since :html is in our list of provided formats, that‘s what we‘ll return. `render` will look for an index.html.erb (or another template format like index.html.mab; see the documentation on Template engines)
2. Almost as simple, /widgets.xml This is very similar. They want :xml, we have :xml, so that‘s what they get. If `render` doesn‘t find an index.xml.builder or similar template, it will call `to_xml` on @widgets. This may or may not do something useful, but you can see how it works.
3. A browser request for /widgets This time the URL doesn‘t say what format is being requested, so we‘ll look to the HTTP Accept: header. If it‘s ’*/*’ (anything), we‘ll use the first format on our list, :html by default.

   If it parses to a list of accepted formats, we‘ll look through them, in order, until we find one we have available. If we find one, we‘ll use that. Otherwise, we can‘t fulfill the request: they asked for a format we don‘t have. So we raise 406: Not Acceptable.

## A more complex example

Sometimes you don‘t have the same code to handle each available format. Sometimes you need to load different data to serve /widgets.xml versus /widgets.txt. In that case, you can use `content_type` to determine what format will be delivered.

        class Widgets < Application
          def action1
            if content_type == :text
              Widget.load_text_formatted(params[:id])
            else
              render
            end
          end

          def action2
            case content_type
            when :html
              handle_html()
            when :xml
              handle_xml()
            when :text
              handle_text()
            else
              render
            end
          end
        end

You can do any standard Ruby flow control using `content_type`. If you don‘t call it yourself, it will be called (triggering content negotiation) by `render`.

Once `content_type` has been called, the output format is frozen, and none of the provides methods can be used.

### Methods

_accept_types _perform_content_negotiation _provided_formats content_type content_type= does_not_provide included only_provides provides

### Classes and Modules

Module Merb::ResponderMixin::ClassMethods
Class Merb::ResponderMixin::ContentTypeAlreadySet

### Constants

TYPES | = | Dictionary.new
MIMES | = | {}
MIME_MUTEX | = | Mutex.new
ACCEPT_RESULTS | = | {}

### Public Class methods

included(base)

#### Parameters

base<Module>: | The module that ResponderMixin was mixed into

:api: private

### Public Instance methods

_accept_types()
_perform_content_negotiation()

Do the content negotiation:

1. if params[:format] is there, and provided, use it
2. Parse the Accept header
3. If it‘s */*, use the first provided format
4. Look for one that is provided, in order of request
5. Raise 406 if none found

:api: private

_provided_formats()

#### Returns

Array[Symbol]: | The current list of formats provided for this instance of the controller. It starts with what has been set in the controller (or :html by default) but can be modifed on a per-action basis.

:api: private

content_type(fmt = nil)

Returns the output format for this request, based on the provided formats, `params[:format]` and the client‘s HTTP Accept header.

The first time this is called, it triggers content negotiation and caches the value. Once you call `content_type` you can not set or change the list of provided formats.

Called automatically by `render`, so you should only call it if you need the value, not to trigger content negotiation.

#### Parameters

fmt<String>: | An optional format to use instead of performing content negotiation. This can be used to pass in the values of opts[:format] from the render function to short-circuit content-negotiation when it‘s not necessary. This optional parameter should not be considered part of the public API.

#### Returns

Symbol: | The content-type that will be used for this controller.

:api: public

content_type=(type)

Sets the content type of the current response to a value based on a passed in key. The Content-Type header will be set to the first registered header for the mime-type.

#### Parameters

type<Symbol>: | The content type.

#### Raises

ArgumentError: | type is not in the list of registered mime-types.

#### Returns

Symbol: | The content-type that was passed in.

:api: plugin

does_not_provide(*formats)

Removes formats from the list of provided formats for this particular request. Usually used to remove formats from a single action. See also the controller-level does_not_provide that affects all actions in a controller.

#### Parameters

*formats<Symbol>: | Registered mime-type

#### Returns

Array[Symbol]: | List of formats that remain after removing the ones not to provide.

:api: public

only_provides(*formats)

Sets list of provided formats for this particular request. Usually used to limit formats to a single action. See also the controller-level only_provides that affects all actions in a controller.

#### Parameters

*formats<Symbol>: | A list of formats to use as the per-action list of provided formats.

#### Returns

Array[Symbol]: | List of formats passed in.

:api: public

provides(*formats)

Adds formats to the list of provided formats for this particular request. Usually used to add formats to a single action. See also the controller-level provides that affects all actions in a controller.

#### Parameters

*formats<Symbol>: | A list of formats to add to the per-action list of provided formats.

#### Raises

Merb::ResponderMixin::ContentTypeAlreadySet: | Content negotiation already occured, and the content_type is set.

#### Returns

Array[Symbol]: | List of formats passed in.

:api: public

[Validate]